<%@include file="include/header.jsp"%>
<%!
//-----------------------------------------------
void updateName(AdminDao dao){
	if(demoFlag){
		errList.add("Not allowed on demo site.");
		return;
	}

	AdminData data = new AdminData();
	data.name = paramString("adminName");

	// Param validation.
	if(!ParamTest.isValidNameLen(data.name)){
		errList.add(ParamTest.ERR_NAME_LEN);
		return;
	}
	
	if(!ParamTest.isValidNameChar(data.name)){
		errList.add(ParamTest.ERR_NAME_CHAR);
		return;
	}

	if(dao.update(data)){
		succList.add("Data updated.");
	}
}

//-----------------------------------------------
void updateAdminPw(AdminDao dao){
	if(demoFlag){
		errList.add("Not allowed on demo site.");
		return;
	}

	String newPw = paramString("newPw");
	String newPw2 = paramString("newPw2");
	String adminPw = paramString("adminPw");

	// Validate and update it.
	if(newPw.length() < 4 || !ParamTest.isValidPasswdLen(newPw)){
		errList.add("Password length must be between 4 and 128.");
		return;
	}
	
	if(!ParamTest.isValidPasswdChar(newPw)){
		errList.add("Only ascii character allowed in password.");
		return;
	}

	if(!dao.isAdminPw(adminPw)){
		errList.add("Wrong password.");
		return;
	}

	if(!newPw.equals(newPw2)){
		errList.add("Password doesn't match.");
		return;
	}

	if(dao.updateAdminPw(newPw)){
		succList.add("Data updated.");
	}
}

//-----------------------------------------------
void updateClientPw(AdminDao dao){
	if(demoFlag){
		errList.add("Not allowed on demo site.");
		return;
	}

	String clientPw = paramString("clientPw");

	// Validate and update it.
	if(!ParamTest.isValidPasswdLen(clientPw)){
		errList.add("Password length must be between 4 and 16.");
		return;
	}
	
	if(!ParamTest.isValidPasswdChar(clientPw)){
		errList.add("Only ascii character allowed in password.");
		return;
	}

	if(dao.updateClientPw(clientPw)){
		succList.add("Data updated.");
	}
}

//-----------------------------------------------
void updateReportPw(AdminDao dao){
	if(demoFlag){
		errList.add("Not allowed on demo site.");
		return;
	}

	String reportPw = paramString("reportPw");

	// Validate and update it.
	if(!ParamTest.isValidPasswdLen(reportPw)){
		errList.add("Password length must be between 4 and 16.");
		return;
	}
	
	if(!ParamTest.isValidPasswdChar(reportPw)){
		errList.add("Only ascii character allowed in password.");
		return;
	}

	if(dao.updateReportPw(reportPw)){
		succList.add("Data updated.");
	}
}
%>
<%
//-----------------------------------------------
// Set permission for this page.
permission.addAdmin();

//Check permission.
if(!checkPermission()){
	return;
}

// Create data access object.
AdminDao dao = new AdminDao();

// Action.
String actionFlag = paramString("actionFlag");
if(actionFlag.equals("update")){
	updateName(dao);
}
if(actionFlag.equals("adminPw")){
	updateAdminPw(dao);
}
if(actionFlag.equals("clientPw")){
	updateClientPw(dao);
}
if(actionFlag.equals("reportPw")){
	updateReportPw(dao);
}

// Global.
AdminData data = dao.selectOne();

// Active tab.
String tabActive0 = "";
String tabActive1 = "";
String tabActive2 = "";
String tabActive3 = "";

String showActive0 = "";
String showActive1 = "";
String showActive2 = "";
String showActive3 = "";

int tabIdx = paramInt("tabIdx");
if(tabIdx == 0){
	tabActive0 = " active";
	showActive0 = " show active";
}
else if(tabIdx == 1){
	tabActive1 = " active";
	showActive1 = " show active";
}
else if(tabIdx == 2){
	tabActive2 = " active";
	showActive2 = " show active";
}
else if(tabIdx == 3){
	tabActive3 = " active";
	showActive3 = " show active";
}
%>
<!-- Action info -->
<%@include file="include/ab-notify.jsp"%>
<!-- /Action info -->

<!-- Breadcrumb -->
<div class="container-fluid primary" style="margin-top:-5px;">
	<ol class="breadcrumb" style="margin-left:10px; margin-right:10px;">
		<li class="breadcrumb-item">Config</li>
		<li class="breadcrumb-item text-info">ADMIN</li>
	</ol>
</div>
<!-- /Breadcrumb -->

<!-- Main content -->
<div class="container-fluid">

	<!-- Tab -->
	<div>
		<ul class="nav nav-tabs" style="margin-left:10px; margin-right:10px;">
			<li class="nav-item" onclick="javascript:$('#tabIdx').val(0); $('#actionFlag').val('update');">
				<a class="nav-link<%= tabActive0%>" data-toggle="tab" href="#tab0">ADMIN NAME</a>
			</li>
			<li class="nav-item" onclick="javascript:$('#tabIdx').val(1); $('#actionFlag').val('adminPw');">
				<a class="nav-link<%= tabActive1%>" data-toggle="tab" href="#tab1">ADMIN PASSWORD</a>
			</li>
			<li class="nav-item" onclick="javascript:$('#tabIdx').val(2); $('#actionFlag').val('clientPw');">
				<a class="nav-link<%= tabActive2%>" data-toggle="tab" href="#tab2">CLIENT PASSWORD</a>
			</li>
			<li class="nav-item" onclick="javascript:$('#tabIdx').val(3); $('#actionFlag').val('reportPw');">
				<a class="nav-link<%= tabActive3%>" data-toggle="tab" href="#tab3">REPORT PASSWORD</a>
			</li>
		</ul>
	</div>
	<!-- Tab -->

	<!-- Form -->
	<form action="<%= getPageName()%>" method="post">
		<input type="hidden" id="actionFlag" name="actionFlag" value="<%= actionFlag%>">
		<input type="hidden" id="tabIdx" name="tabIdx" value="<%= tabIdx%>">

		<!-- Tab content -->
		<div id="myTabContent" class="tab-content">

			<!-- Admin Name -->
			<div class="tab-pane <%= showActive0%>" id="tab0">
				<div class="card bg-light m-2 expand-lg">
					<div class="card-body">
						<fieldset>
							<div class="form-group col-lg-8">
								<label class="col-form-label">Admin Name</label>
								<input type="text" class="form-control" id="adminName" name="adminName" value="<%= data.name%>">
							</div>
							<div class="form-group col-lg-8">
								<button type="submit" class="btn btn-primary">Submit</button>
							</div>
						</fieldset>
					</div>
				</div>
			</div>
			<!-- /Admin Name -->

			<!-- Admin Password -->
			<div class="tab-pane fade<%= showActive1%>" id="tab1">
				<div class="card bg-light m-2 expand-lg">
					<div class="card-body">
						<fieldset>
							<div class="form-group col-lg-8">
								<label class="col-form-label">Current Password</label>
								<input type="password" class="form-control" id="adminPw" name="adminPw">
							</div>
							<div class="form-group col-lg-8">
								<label class="col-form-label">New Password</label>
								<input type="password" class="form-control" id="newPw" name="newPw">
							</div>
							<div class="form-group col-lg-8">
								<label class="col-form-label">Confirm Password</label>
								<input type="password" class="form-control" id="newPw2" name="newPw2">
							</div>
							<div class="form-group col-lg-8">
								<button type="submit" class="btn btn-primary">Submit</button>
							</div>
						</fieldset>
					</div>
				</div>
			</div>
			<!-- /Admin Password -->

			<!-- Client Password -->
			<div class="tab-pane fade<%= showActive2%>" id="tab2">
				<div class="card bg-light m-2 expand-lg">
					<div class="card-body">
						<fieldset>
							<div class="form-group col-lg-8">
								<label class="col-form-label">
									Client Password
									<i class="fa fa-question-circle south-east" title="Password for CxBlock setup page (chrome://extension) on Chromebook."></i>
								</label>
								<input type="password" class="form-control" id="clientPw"
									name="clientPw" value="<%= data.clientPw%>" onclick="javascript:this.type='text';" onblur="javascript:this.type='password';">
							</div>
							<div class="form-group col-lg-8">
								<button type="submit" class="btn btn-primary">Submit</button>
							</div>
						</fieldset>
				</div>
			</div>
		</div>
		<!-- /Client Password -->

		<!-- Report Password -->
		<div class="tab-pane fade<%= showActive3%>" id="tab3">
			<div class="card bg-light m-2 expand-lg">
				<div class="card-body">

						<fieldset>
							<div class="form-group col-lg-8">
								<label class="col-form-label">
									Report Password
									<i class="fa fa-question-circle south-east" title="Password for report manager permission."></i>
								</label>
								<input type="password" class="form-control" id="reportPw"
									name="reportPw" value="<%= data.reportPw%>" onclick="javascript:this.type='text';" onblur="javascript:this.type='password';">
							</div>
							<div class="form-group col-lg-8">
								<button type="submit" class="btn btn-primary">Submit</button>
							</div>
						</fieldset>
					</div>
				</div>
			</div>
			<!-- /Report Password -->

		</div>
		<!-- Tab content -->

	</form>
	<!-- /Form -->

</div>
<!-- /Main content -->

<%@include file="include/footer.jsp"%>
