<%@include file="include/header.jsp"%>
<%
//-----------------------------------------------
// Set permission for this page.
permission.addAdmin();
permission.addReport();

//Check permission.
if(!checkPermission()){
	return;
}

// Global.
String gUser = paramString("user");
String gUptime = new ConfigDao().getUptimeInfo();
%>
<!-- Action info -->
<%@include file="include/ab-notify.jsp"%>
<!-- /Action info -->

<!-- Breadcrumb -->
<div class="container-fluid primary" style="margin-top:-5px;">
	<ol class="breadcrumb" style="margin-left:10px; margin-right:10px;">
		<li class="breadcrumb-item">REPORT</li>
		<li class="breadcrumb-item text-info">USAGE</li>
		<li class="breadcrumb-item">Up <%= gUptime%></li>
	</ol>
</div>
<!-- /Breadcrumb -->

<!-- Form -->
<div class="container-fluid">
	<div class="card bg-light m-2 expand-lg">
		<div class="card-body">
			<form action="<%= getPageName()%>" method="get">
				<input type="hidden" name="actionFlag">
				<div class="form-group col-lg-8">
					<label class="col-form-label">User</label>
					<input type="text" class="form-control" id="user" name="user" value="<%= gUser%>">
				</div>
				<div class="form-group col-lg-8">
					<button type="submit" class="btn btn-primary">Submit</button>
				</div>
			</form>
		</div>
	</div>
</div>
<!-- /Form -->

<!-- List -->
<div id="listDiv" class="container-fluid" style="display: none;">
	<div class="m-2 expand-lg">
		<table id="list" class="cell-border hover" style="width:100%">
			<thead>
				<tr>
					<th>Time</th>
					<th>Request Sum</th>
					<th>Request Count</th>
					<th>Block Sum</th>
					<th>Block Count</th>
					<th>Domain Count</th>
					<th>User Count</th>
					<th>Client IP</th>
				</tr>
			</thead>
			<tbody>
<%
for(int i = 0; i < 30; i++){
	String stime = strftimeAdd("yyyyMMdd", (86400 * i * -1) - 1);

	D1ReportDao dao = new D1ReportDao(stime, gUser);
	ReportStatsData stats = dao.getStats();
%>
				<tr>
					<td><%= dao.getStime()%></td>
					<td><%= stats.reqSum%></td>
					<td><%= stats.reqCnt%></td>
					<td><%= stats.blockSum%></td>
					<td><%= stats.blockCnt%></td>
					<td><%= stats.domainCnt%></td>
					<td><%= stats.userCnt%></td>
					<td><%= stats.cltIpCnt%></td>
				</tr>
<%}%>
			</tbody>
		</table>
	</div>
</div>
<!-- /List -->

<%@include file="include/footer.jsp"%>

<script>
$(document).ready(function(){
	$("#list").DataTable({
		"bFilter" : false,
		"paging" : false,
		"ordering" : false,
		"info" : true,
		"columnDefs": [{
			"targets": 2,
			"width": "50"
		}],
		"initComplete": function(settings, json){
			$("#listDiv").show();
		},
	});
});
</script>
